searchNodes=[{"doc":"A package for authenticating with an oauth2 token and building an ueberauth struct. Features: Cache the ueberauth struct response using the excellent whitfin/cachex library. Perform asynchronyous validity checks for each token key in the cache. See full description of the config options can be found in UeberauthToken.Config @moduledoc. Defining an provider module An provider module must be provided in order for UeberauthToken to function correctly. The provider implements the callbacks specified in the module UeberauthToken.Strategy . Read more about the requirements for the provider in UeberauthToken.Strategy . Read more on basic usage in the UeberauthToken.Strategy module.","ref":"UeberauthToken.html","title":"UeberauthToken","type":"module"},{"doc":"Execute token validation for an oauth2 bearer token against a given oauthorization server (provider). This function may be useful when a token needs to be validated by a resource server and the validation is taking place outside a Plug pipeline. For example, in a web socket connection. Options * ` :validate_provider ` - boolean Defaults to ` true ` . Validates that the provider has already been configured in the application configuration . It is recommended to set this value to ` [ validate_provider : false ] ` once it is known that the application is correctly configured to reduce the runtime burden of checking the configuration on each token validation event . Example usage @provider UeberauthToken.TestProvider def connect ( %{ &quot;authorization&quot; =&gt; token } = params , socket ) do case UeberauthToken . token_auth ( token , @provider ) do { :ok , % Ueberauth.Auth { } = auth } -&gt; { :ok , assign ( socket , :user_id , auth . uid ) } { :error , % Ueberauth.Failure { } = failure } -&gt; { :error , failure } end end","ref":"UeberauthToken.html#token_auth/3","title":"UeberauthToken.token_auth/3","type":"function"},{"doc":"Helper functions for ueberauth_token configuration. Cachex may be used for the storage of tokens temporarily by setting the option :use_cache to true . Cached tokens increase speed of token payload lookup but with the tradeoff that token invalidation may be delayed. This can optionally be mitigated somewhat by also using the background token worker inconjunction with the cached token. Example configuration config :ueberauth_token , UeberauthToken.Config , providers : { :system , :list , &quot;TEST_TOKEN_PROVIDER&quot; , [ UeberauthToken.TestProvider ] } config :ueberauth_token , UeberauthToken.TestProvider , use_cache : { :system , :boolean , &quot;TEST_USE_CACHE&quot; , false } , cache_name : { :system , :atom , &quot;TEST_CACHE_NAME&quot; , :ueberauth_token } , background_checks : { :system , :boolean , &quot;TEST_BACKGROUND_CHECKS&quot; , false } , background_frequency : { :system , :integer , &quot;TEST_BACKGROUND_FREQUENCY&quot; , 120 } , background_worker_log_level : { :system , :integer , &quot;TEST_BACKGROUND_WORKER_LOG_LEVEL&quot; , :warn } Configuration options * ` :use_cache ` - boolean Whether or not the cache should be used at all . If set to true , the Cachex worker will be started in the supervision tree and the token will be cached . * ` :background_checks ` - boolean Whether or not to perform background checks on the tokens in the cache . If set to true , the ` UeberauthToken.Worker ` is started in the supervision tree . If unset , defaults to ` false ` * ` :background_frequency ` - seconds as an integer The frequency with which each token in the cache will be checked . The checks are not applied all at once , but staggered out across the ` background_frequency ` value in 30 evenly graduated phasese to avoid a burst of requests for the token verification . Defaults to ` 300 ` ( 5 minutes ) . * ` :background_worker_log_level ` - ` :debug ` , ` :info ` , ` :warn ` or ` :error ` The log level at which the background worker will log unexpected timeout and terminate events . Defaults to ` :warn ` * ` :cache_name ` - an atom The ets table name for the cache * ` :provider ` - a module a required provider module which implements the callbacks defined in ` UeberauthToken.Strategy ` . See ` UeberauthToken.Strategy `","ref":"UeberauthToken.Config.html","title":"UeberauthToken.Config","type":"module"},{"doc":"Whether the background checks on the token will be performed or not. Defaults to false","ref":"UeberauthToken.Config.html#background_checks?/1","title":"UeberauthToken.Config.background_checks?/1","type":"function"},{"doc":"The average frequency with which background checks should be performed. Defaults to 300 seconds.","ref":"UeberauthToken.Config.html#background_frequency/1","title":"UeberauthToken.Config.background_frequency/1","type":"function"},{"doc":"The log level at which the background worker will log unexpected timeout and terminate events. Defaults to :warn","ref":"UeberauthToken.Config.html#background_worker_log_level/1","title":"UeberauthToken.Config.background_worker_log_level/1","type":"function"},{"doc":"Get the name for the cache. Defaults to underscored provider name concatenated with ueberauth_token .","ref":"UeberauthToken.Config.html#cache_name/1","title":"UeberauthToken.Config.cache_name/1","type":"function"},{"doc":"Get the configuration for a given provider.","ref":"UeberauthToken.Config.html#provider_config/1","title":"UeberauthToken.Config.provider_config/1","type":"function"},{"doc":"Get the list of configured providers.","ref":"UeberauthToken.Config.html#providers/0","title":"UeberauthToken.Config.providers/0","type":"function"},{"doc":"Whether the cache is to be started and used or not. Defaults to true if not set","ref":"UeberauthToken.Config.html#use_cache?/1","title":"UeberauthToken.Config.use_cache?/1","type":"function"},{"doc":"Validates a provider as one which has been specified in the configuration. Raises and error if the provider is not configured.","ref":"UeberauthToken.Config.html#validate_provider!/1","title":"UeberauthToken.Config.validate_provider!/1","type":"function"},{"doc":"Validates a provider as one which has been specified in the configuration","ref":"UeberauthToken.Config.html#validate_provider/1","title":"UeberauthToken.Config.validate_provider/1","type":"function"},{"doc":"An implementation of Ueberauth token validation in a plug pipeline In order for there to be successful authentication, the Plug.Conn should have a request header in the following format: % Plug.Conn { req_headers : [ %{ &quot;authorization&quot; =&gt; &quot;Bearer &lt;token&gt;&quot; } ] } Example Usage Typically, UeberauthToken.Plug would be used as part of plug pipeline in an api for the validation phase of an oauth2 token. The client will be in possession of a token an is making a request for a resource. This plug validates the requests and assigns an Ueberauth struct to the %Conn{} pipeline :api do plug :accepts , [ &quot;json&quot; ] plug UeberauthToken.Plug , provider : UeberauthToken.TestProvider end Options - * ` :provider ` - a module The provider may be passed in as an option if more than one provider is configured . The plug pipeline ` plug UeberauthToken.Plug ` should only be called once in a given plug pipeline , in other words only one provider per plug pipeline is supported .","ref":"UeberauthToken.Plug.html","title":"UeberauthToken.Plug","type":"module"},{"doc":"Callback implementation for Plug.call/2 .","ref":"UeberauthToken.Plug.html#call/2","title":"UeberauthToken.Plug.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1 .","ref":"UeberauthToken.Plug.html#init/1","title":"UeberauthToken.Plug.init/1","type":"function"},{"doc":"A workflow for validation of oauth2 tokens on the resource server. The strategy handle_callback/1 function is invoked for validation token calidation in either of the following cases: As a plug in a plug pipeline which assigns an ueberauth struct to %Conn{} pipeline :api do plug :accepts, [&quot;json&quot;] plug UeberauthToken.Plug, provider: UeberauthToken.TestProvider end As a plug, the callback phase of ueberauth is adapted to validate the oauth2 access token. The ueberauth struct is returned in the assigns fields of the struct in one of the two following ways: # Failed validation Plug.Conn { assigns : %{ ueberauth_failure : % Ueberauth.Failure { } } } # Successful validation Plug.Conn { assigns : %{ ueberauth_auth : % Ueberauth.Auth { } } } As a token_auth/3 function call which returns an ueberauth struct. token_auth(token, provider, []) The token_auth/3 validation function returns one of the following forms: # Failed validation % Ueberauth.Failure { } # Successful validation % Ueberauth.Auth { } See full description of the config options in UeberauthToken.Config @moduledoc. Defining an provider module An provider module must be specified in order for UeberauthToken to know what authorization server provider to validate against. The provider must implement the callbacks specified in the module UeberauthToken.Strategy . The following functions should be implemented by the provider module: @callback get_payload ( token :: String . t ( ) , opts :: list ( ) ) :: { :ok , map ( ) } | { :error , map ( ) } @callback valid_token? ( token :: String . t ( ) , opts :: list ) :: boolean ( ) @callback get_uid ( conn :: Conn . t ( ) ) :: any ( ) @callback get_credentials ( conn :: Conn . t ( ) ) :: Credentials . t ( ) @callback get_info ( conn :: Conn . t ( ) ) :: Info . t ( ) @callback get_extra ( conn :: Conn . t ( ) ) :: Extra . t ( ) @callback get_ttl ( conn :: Conn . t ( ) ) :: integer ( ) For a basic example of token validation in a plug pipeline, see UeberauthToken.Plug For a basic example of token validation as a function, see UeberauthToken.token_auth/3","ref":"UeberauthToken.Strategy.html","title":"UeberauthToken.Strategy","type":"behaviour"},{"doc":"","ref":"UeberauthToken.Strategy.html#extract_token/1","title":"UeberauthToken.Strategy.extract_token/1","type":"function"},{"doc":"To populate the ueberauth credentials struct from the payload in :ueberauth_token private conn field. Callback function to be implemented by the provider","ref":"UeberauthToken.Strategy.html#c:get_credentials/1","title":"UeberauthToken.Strategy.get_credentials/1","type":"callback"},{"doc":"To populate the ueberauth extra struct from the payload in :ueberauth_token private conn field. Callback function to be implemented by the provider","ref":"UeberauthToken.Strategy.html#c:get_extra/1","title":"UeberauthToken.Strategy.get_extra/1","type":"callback"},{"doc":"To populate the ueberauth info struct from the payload in :ueberauth_token private conn field. Callback function to be implemented by the provider","ref":"UeberauthToken.Strategy.html#c:get_info/1","title":"UeberauthToken.Strategy.get_info/1","type":"callback"},{"doc":"To get the payload. Callback function to be implemented by the provider The payload in turn is put into a private field :ueberauth_token . The payload is the map from which other callback functions will need to build the :ueberauth structs.","ref":"UeberauthToken.Strategy.html#c:get_payload/2","title":"UeberauthToken.Strategy.get_payload/2","type":"callback"},{"doc":"To get the ttl from the ueberauth struct. The ttl must be returned n milliseconds. Callback function to be implemented by the provider","ref":"UeberauthToken.Strategy.html#c:get_ttl/1","title":"UeberauthToken.Strategy.get_ttl/1","type":"callback"},{"doc":"To populate the ueberauth uid struct from the payload in :ueberauth_token private conn field. Callback function to be implemented by the provider","ref":"UeberauthToken.Strategy.html#c:get_uid/1","title":"UeberauthToken.Strategy.get_uid/1","type":"callback"},{"doc":"Handles the callback as follows: Extracts token from &quot;Bearer token&quot; if it is in that format Tries to get the token data from the cache if The cache is turned on The token is present in the cache already If this stage successfully retrieves the token, then subsequent steps will be skipped. By way of a callback function, it seeks data for populating the ueberauth struct using the token. The callback function must be provided through an provider in the config or can be provided manually in the conn.assigns field. The provider will cache the data if the use_cache configuration option is set to true.","ref":"UeberauthToken.Strategy.html#handle_callback!/1","title":"UeberauthToken.Strategy.handle_callback!/1","type":"function"},{"doc":"Clean up private fields after construction of the Ueberauth struct","ref":"UeberauthToken.Strategy.html#handle_cleanup!/1","title":"UeberauthToken.Strategy.handle_cleanup!/1","type":"function"},{"doc":"","ref":"UeberauthToken.Strategy.html#rework_error_struct/2","title":"UeberauthToken.Strategy.rework_error_struct/2","type":"function"},{"doc":"Verifies a token. Callback function to be implemented by the provider.","ref":"UeberauthToken.Strategy.html#c:valid_token?/2","title":"UeberauthToken.Strategy.valid_token?/2","type":"callback"},{"doc":"UeberauthToken.Worker is a background worker which verifies the authenticity of the cached active tokens. Tokens will be removed after their expiry time when the :ttl option is set by the Cachex.put function. However, if one wants to be more aggressive in checking the cached token validity then this module can be optionally activated. See full description of the config options in UeberauthToken.Config @moduledoc.","ref":"UeberauthToken.Worker.html","title":"UeberauthToken.Worker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"UeberauthToken.Worker.html#child_spec/1","title":"UeberauthToken.Worker.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"UeberauthToken.Worker.html#init/1","title":"UeberauthToken.Worker.init/1","type":"function"},{"doc":"","ref":"UeberauthToken.Worker.html#periodic_checking/1","title":"UeberauthToken.Worker.periodic_checking/1","type":"function"},{"doc":"","ref":"UeberauthToken.Worker.html#start_link/1","title":"UeberauthToken.Worker.start_link/1","type":"function"},{"doc":"","ref":"UeberauthToken.Worker.html#worker_details/1","title":"UeberauthToken.Worker.worker_details/1","type":"function"},{"doc":"Error raised when the request authorization token is not valid","ref":"Plug.Conn.TokenParsingError.html","title":"Plug.Conn.TokenParsingError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Plug.Conn.TokenParsingError.html#message/1","title":"Plug.Conn.TokenParsingError.message/1","type":"function"}]